// ----------------------------------------------------------------------------
//
//  Project File:  CallingBB.CPP
//					A partial program that uses LoadLibrary to 
//					access MakeBackupCD from BackupBurner.dll.
//
//	Edit the program path value before compiling.
//
//  Demo for use with Backup-Burner Add-on SDK
//  February, 2002
//  Desernet Broadband Media, Inc.
//  Produced by: D. Clark
//
//  Compiles in Borland C++Builder 5 without warnings or errors.
//
// ----------------------------------------------------------------------------

#include <windows.h>

VOID main(VOID)
{

	// Uses a StdCall calling convention.
        // CALLBACK is not required in BCB.
	typedef int (CALLBACK *MakeBackupCDPtr)(const char *szBBRegName,
						const char *szBBRegCode,
						const char *szBBVolume,
						const char *szBBTitle,
					        const char *szBBColorForm,
						const char *szBBColorText,
						const char *szPathtoBackupFolder,
	  					      char *szBBFutureUse);

	MakeBackupCDPtr lpfnMakeBackupCD;

	HINSTANCE hDLL; //Choose one
	//HMODULE hDLL;

	int  iResultCode;
	char szBBRegName[32];
	char szBBRegCode[512];
	char szBBVolume[16];
	char szBBTitle[128];
	char szBBColorForm[32];
	char szBBColorText[32];
	char szPathtoBackupFolder[512];
	char szBBFutureUse[512];

        strcpy(szBBRegName	,  "DEMOUSER");
        strcpy(szBBRegCode	,  "ABCD1234");
        strcpy(szBBVolume	,  "MyBackupCD");// What ever you want here, but no spaces allowed
        strcpy(szBBTitle	,  "My Project's Name is __");//This shows up on the form.
        strcpy(szBBColorForm	,  "clSilver");//default is clSilver, don't use hex color
        strcpy(szBBColorText	,  "clBlack");//default is clBlack, don't use hex color
        strcpy(szPathtoBackupFolder,  "c:\\myprogpath\\FilesToBackup\\");
        strcpy(szBBFutureUse	,  "");

	hDLL = LoadLibrary("c:\\myprogpath\\Bin\\BackupBurner.dll");

	if(hDLL == NULL)
	{
		// handle error
		exit(1);
	}

	lpfnMakeBackupCD = (MakeBackupCDPtr) GetProcAddress(hDLL, "MakeBackupCD");

	if(lpfnMakeBackupCD == NULL)
	{
		// handle error
		exit(1);
	}


	iResultCode = (*lpfnMakeBackupCD)(szBBRegName,
                                          szBBRegCode,
				          szBBVolume,
				          szBBTitle,
				          szBBColorForm,
				          szBBColorText,
				          szPathtoBackupFolder,
				          szBBFutureUse);

	switch (iResultCode)
	{
		case -2:// ResultCode = -2 Installation Error- version mismatch';
			break;
		case -1:// ResultCode = -1 User canceled' ;
			break;
		case 0:	// ResultCode = 0  it was a successful burn!
			break;
		case 1: // ResultCode = 1  User canceled
			break;
		case 2: // ResultCode = 2  Installation Error- files missing';
			break;
		case 3: // ResultCode = 3  Insufficent disk space';
			break;
		case 5: // ResultCode = 5  there was not a blank CD';
			break;
		case 7: // ResultCode = 7  bad burn during writing ';
			break;
		case 8: // ResultCode = 8  no CD recorder detected. ' 
			break;
		case 9: // ResultCode = 9  Demo expired.'
			break;
		case 11: // ResultCode = 11 User does not have admin rights to access the ASPI manager.'
			break;
		default:
			break;
	}

	FreeLibrary(hDLL);
	exit(0);
}

